using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace FunctionalMandelbrotParallel {
  // There's Windows.Foundation.Point, but we can't use it
  public struct Point {
    private int x;
    private int y;
    public Point(int x, int y) {
      this.x = x;
      this.y = y;
    }
    public int X {
      get { return this.x; }
      set { this.x = value; }
    }
    public int Y {
      get { return this.y; }
      set { this.y = value; }
    }
  }

  // There's Windows.UI.Color, but we can't use that either
  public struct Color {
    public static readonly Color Empty = new Color();
    private long value;

    private Color(long value) {
      this.value = value;
    }

    public static Color FromArgb(int red, int green, int blue) {
      return FromArgb(0xff, red, green, blue);
    }

    public static Color FromArgb(int alpha, int red, int green, int blue) {
      return new Color(MakeArgb((byte) alpha, (byte) red, (byte) green, (byte) blue));
    }

    public int ToArgb() {
      return (int) this.value;
    }

    private static long MakeArgb(byte alpha, byte red, byte green, byte blue) {
      return (long) (((ulong) ((((red << 0x10) | (green << 8)) | blue) | (alpha << 0x18))) & 0xffffffffL);
    }

    public static Color White { get { return FromArgb(0xff, 0xff, 0xff); } }
    public static Color Black { get { return FromArgb(0, 0, 0); } }

  }
}
