﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace RubberChickenManager.Complete {
  /// <summary>
  /// An empty page that can be used on its own or navigated to within a Frame.
  /// </summary>
  public sealed partial class MainPage : Page {
    public MainPage() {
      this.InitializeComponent();

      rubberChickens = new ObservableCollection<RubberChicken> {
        new RubberChicken{ViewName = "Rubber Chicken with a button on its head"},
        new RubberChicken{ViewName = "Rubber Chicken with a pulley"},
        new RubberChicken{ViewName = "Precious little blue rubber chicken"}
      };

      listbox.ItemsSource = rubberChickens;
    }


    ObservableCollection<RubberChicken> rubberChickens;

    /// <summary>
    /// Invoked when this page is about to be displayed in a Frame.
    /// </summary>
    /// <param name="e">Event data that describes how this page was reached.  The Parameter
    /// property is typically used to configure the page.</param>
    protected override void OnNavigatedTo(NavigationEventArgs e) {
    }

    private async void Button_Click_1(object sender, RoutedEventArgs e) {
      //var dlg = new MessageDialog("You are going to give away a rubber chicken. Whoa!");
      //await dlg.ShowAsync();
      //rubberChickens.RemoveAt(0);

      var dlg = new MessageDialog("Are you sure you want to give away a rubber chicken?");
      dlg.Commands.Add(new UICommand("Yeah, cool", RemoveChicken));
      dlg.Commands.Add(new UICommand("What was I thinking!", NoAction));

      await dlg.ShowAsync();
    }

    void RemoveChicken(IUICommand cmd) {
      rubberChickens.RemoveAt(0);
    }

    void NoAction(IUICommand cmd) { }
  }


  public class RubberChicken {
    public string ViewName { get; set; }
  }
}
